-- vim:set ft=lua:

-- This script shall start mag. For that we need a frame-buffer and io to
-- get access to the required hardware resources. Target platform is x86.

require("L4");


local l = L4.default_loader;

local io_buses =
  {
    gui   = l:new_channel();
    fbdrv = l:new_channel();
  };

l:start({
          caps = {
            gui    = io_buses.gui:svr(), 
            fbdrv  = io_buses.fbdrv:svr(), 

	    icu    = L4.Env.icu,
	    sigma0 = L4.cast(L4.Proto.Factory, L4.Env.sigma0):create(L4.Proto.Sigma0),
          },
          log      = { "IO", "y" },
        },
        "rom/io rom/x86-legacy.devs rom/x86-fb.io");

local fbdrv_fb = l:new_channel();

l:start({
           caps = {
	     vbus = io_buses.fbdrv,
	     fb   = fbdrv_fb:svr(),
	   },
           log      = { "fbdrv", "r" },
         },
         "rom/fb-drv -m 0x114");

local mag_caps = {
                   mag = l:new_channel(),
		   svc = l:new_channel(),
                 };

l:start({
          caps = {
	    vbus = io_buses.gui,
	    fb   = fbdrv_fb,
	    mag  = mag_caps.mag:svr(),
	    svc  = mag_caps.svc:svr(),
	  },
          log      = { "mag", "g" },
	  -- scheduler = L4.Env.user_factory:create(L4.Proto.Scheduler, 0xa0, 0x80),
        },
	"rom/mag");

local con_caps = {
		   con = l:new_channel(),
                 };


l:start({
          caps = {
	    vbus = io_buses.gui,
	    fb   = fbdrv_fb,
	    con  = con_caps.con:svr(),
	  },
        },
	"rom/con");

l:start({
          caps = {
	    vbus = io_buses.gui,
	    fb   = fbdrv_fb,
	    con  = con_caps.con,
	  },
        },
	"rom/fbterminal");

